#######################################################################
#
#    dream Notifications for Enigma2
#    by Christian Fees
#
#######################################################################

import os
from Plugins.Plugin import PluginDescriptor
from Tools import Notifications
from Screens.MessageBox import MessageBox
from WebChilds.UploadResource import UploadResource
from DNwebsite import DNweb
from Plugins.Extensions.WebInterface.WebChilds.Toplevel import addExternalChild
from twisted.web import static

def main(session, **kwargs):
	print "[dream Notifications] Plugin start"
	
def autostart(reason, **kwargs):
	print "[dream Notifications] Plugin Autostart"
	global session
	if reason == 0 and kwargs.has_key("session"):
		if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/__init__.pyo"):
			print "[dream Notifications] Registering Webinterface plugin hook"
			if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web/external.xml"):
				root = static.File("/usr/lib/enigma2/python/Plugins/Extensions/DreamNotifications/web")
				print "[dream Notifications] Adding webinterface external child"
				try:
					root.putChild("", DNweb(kwargs["session"]))
					root.putChild("upload", UploadResource(kwargs["session"]))
					addExternalChild( ("dn", root, "Dream Notifications", 1, False) )
					print "[dream Notifications] Done adding webinterface external child"
				except Exception, e:
					print "[dream Notifications] Exception while adding webinterface external child: " + str(e)
					try:
						addExternalChild( ("dn", root) )
						print "[dream Notifications] Done adding webinterface external child fallback"
					except Exception, e:
						print "[dream Notifications] Exception while adding webinterface external child fallback: " + str(e)
						pass
					pass
		if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/OpenWebif/__init__.pyo"):
			try:
				if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/OpenWebif/pluginshook.src"):
					print "[dream Notifications] Adding OpenWebIf external child"
					try:
						root = static.File("/usr/lib/enigma2/python/Plugins/Extensions/DreamNotifications/web")
						root.putChild("", DNweb(kwargs["session"]))
						root.putChild("upload", UploadResource(kwargs["session"]))
						addExternalChild( ("dn", root, "Dream Notifications", 1) )
						print "[dream Notifications] Done adding OpenWebIf external child"
					except Exception, e:
						print "[dream Notifications] Exception while adding OpenWebif external child: " + str(e)
						pass		
			except Exception, e:
				print "[dream Notifications] Exception while adding OpenWebif: " + str(e)
				pass
		
def Plugins(**kwargs):
	list = [
	PluginDescriptor(name="dream Notifications",
	description="Display notifications from your phone",
	where = [PluginDescriptor.WHERE_SESSIONSTART, 
	PluginDescriptor.WHERE_AUTOSTART], 
	fnc = autostart)]
	return list